#pragma comment(linker,"/subsystem:Windows,5")
#pragma comment(linker,"/version:5")

#ifdef NDEBUG
	//#pragma comment(linker,"/MERGE:.rdata=.text")
	//#pragma comment(linker,"/FILEALIGN:512 /SECTION:.text,EWRX /IGNORE:4078")
	//#pragma comment(linker,"/opt:nowin98")
	//#pragma comment(linker,"/nodefaultlib")
	#pragma comment(linker,"/ENTRY:WinMainEx")
#endif //_DEBUG


#define WINVER       0x0500
#define _WIN32_WINNT 0x0500
#define UNICODE
#define _UNICODE


// Windows Header Files:
#include <windows.h>
#include <commdlg.h>
#include <shlobj.h>
#include <tchar.h>
#include "MemoryFind.h"
#include "CRCFileCheck.h"
#include "ReportError.h"


#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"shlwapi.lib")


// http://www.ixbt.com/mobile/review/obex.shtml




#define MAX_PATH_LEN 32768


static char char16table[128] = {
    -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
     0, 1, 2, 3,  4, 5, 6, 7,  8, 9,-1,-1, -1,-1,-1,-1,
    -1,10,11,12, 13,14,15,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    -1,10,11,12, 13,14,15,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1
};

#define char16enc(c) (((c)&0x80) ? -1:char16table[(c)])
DWORD QPUTF8_To_QPWin1251(LPBYTE lpBuff,SIZE_T dwBuffSize,LPBYTE lpBuffOut,SIZE_T dwBuffOutSize,SIZE_T *pdwBuffOutSizeRet);



__inline BYTE ByteFromHex(WORD wHex)
{
	BYTE bRet,bHex[2];

	(*(WORD*)&bHex)=wHex;

	bRet=((char16enc(bHex[0]) << 4 | char16enc(bHex[1])) & 0xff);

return(bRet);
};






#ifdef _DEBUG
	#ifdef UNICODE
		int APIENTRY wWinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPWSTR lpCmdLine,int nCmdShow)
	#else
		int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
	#endif
#else
	void WinMainEx(void)
#endif //_DEBUG
{
	#ifdef NDEBUG
		HINSTANCE	hInstance		=GetModuleHandle(NULL);
		HINSTANCE	hPrevInstance	=NULL;
		LPTSTR		lpCmdLine		=GetCommandLine();
		int			nCmdShow		=0;
	#endif //_DEBUG

	DWORD dwRet=NO_ERROR;


	//    
	dwRet=CRCFileCheck();

	if (dwRet==NO_ERROR)
	{//     
		BOOL bConvert=FALSE;
		DWORD i=0,tm;
		BYTE btBuff[65535];
		HANDLE hFile,hFileMap,hFileVCard;
		LPVOID lpFileData,lpBeginVCard,lpEndVCard;
		SIZE_T dwFileSize,dwBuffSize;
		WCHAR szFilter[MAX_PATH],szVCardsFileName[MAX_PATH_LEN],szVCardsSavePath[MAX_PATH_LEN],szVCardSaveFileName[MAX_PATH_LEN];


		OPENFILENAME ofn={0};

		lstrcpy(szFilter,TEXT("stg file (*.stg)|*.stg|all files|*.*||"));
		for(tm=0;szFilter[tm];tm++)
		{
			if (szFilter[tm]=='|') szFilter[tm]=0;
		}
		szVCardsFileName[0]=0;
		ofn.lStructSize			=sizeof(OPENFILENAME); 
		//ofn.hwndOwner			=NULL; 
		ofn.lpstrFilter			=szFilter;
		//ofn.nFilterIndex		=iFilter; 
		ofn.lpstrFile			=szVCardsFileName; 
		ofn.nMaxFile			=MAX_PATH_LEN; 
		ofn.lpstrTitle			=TEXT("Opening V Cards file");
		//ofn.lpstrInitialDir	=0;
		ofn.Flags				=(OFN_FILEMUSTEXIST | OFN_EXPLORER | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST); 
		//ofn.lpstrCustomFilter	=NULL;
		//ofn.nMaxCustFilter	=0;
		//ofn.nFileOffset		=0;
		//ofn.nFileExtension	=0;
		//ofn.lpstrDefExt		=NULL;
		//ofn.lpTemplateName	=NULL;
		//ofn.lpfnHook			=0; 
		//ofn.lCustData			=0;
		//ofn.lpstrFileTitle	=NULL;
		//ofn.nMaxFileTitle		=0;
		ofn.hInstance			=hInstance;

		if (GetOpenFileName(&ofn))
		{
			LPCITEMIDLIST pidl;
			BROWSEINFO biBrowseInfo={0};
			
			biBrowseInfo.lpszTitle=TEXT("Select V Cards save path");
			SHGetSpecialFolderLocation(NULL,CSIDL_DESKTOP,(LPITEMIDLIST*)&biBrowseInfo.pidlRoot);
			biBrowseInfo.ulFlags=(BIF_RETURNONLYFSDIRS|BIF_EDITBOX|BIF_NEWDIALOGSTYLE|BIF_UAHINT);

			pidl=SHBrowseForFolder(&biBrowseInfo);
			if (pidl)
			{
				SHGetPathFromIDList(pidl,szVCardsSavePath);
				CoTaskMemFree((LPVOID)pidl);


				tm=MessageBox(NULL,TEXT("Do you want convert from UTF-8 to win 1251?"),TEXT("V Cards extractor"),(MB_YESNOCANCEL|MB_ICONQUESTION|MB_DEFBUTTON1));

				if (tm!=IDCANCEL)
				{
					if (tm==IDYES) bConvert=TRUE;

					hFile=CreateFile(szVCardsFileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,(FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN),NULL);
					if (hFile!=INVALID_HANDLE_VALUE)
					{
						dwFileSize=GetFileSize(hFile,NULL);
						hFileMap=CreateFileMapping(hFile,NULL,PAGE_READONLY,0,0,NULL);
						if (hFileMap)
						{
							lpFileData=MapViewOfFile(hFileMap,FILE_MAP_READ,0,0,dwFileSize);
							if (lpFileData)
							{
								lpEndVCard=lpFileData;

								while(TRUE)
								{
									lpBeginVCard=MemoryFind((((SIZE_T)lpEndVCard)-((SIZE_T)lpFileData)),lpFileData,dwFileSize,"BEGIN:VCARD",11);
									if (lpBeginVCard)
									{
										lpEndVCard=MemoryFind((((SIZE_T)lpBeginVCard)-((SIZE_T)lpFileData)),lpFileData,dwFileSize,"END:VCARD",9);
										if (lpEndVCard)
										{
											wsprintf(szVCardSaveFileName,TEXT("%s\\%05d.vcf"),szVCardsSavePath,i);
											hFileVCard=CreateFile(szVCardSaveFileName,GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
											if (hFileVCard!=INVALID_HANDLE_VALUE)
											{
												if (bConvert)
												{
													QPUTF8_To_QPWin1251((LPBYTE)lpBeginVCard,((((SIZE_T)lpEndVCard)-((SIZE_T)lpBeginVCard))+9),btBuff,sizeof(btBuff),&dwBuffSize);
													WriteFile(hFileVCard,&btBuff,dwBuffSize,&tm,NULL);
												}else{
													WriteFile(hFileVCard,lpBeginVCard,((((SIZE_T)lpEndVCard)-((SIZE_T)lpBeginVCard))+9),&tm,NULL);
												}
												CloseHandle(hFileVCard);
											}else{
												dwRet=GetLastError();
												break;
											}
											i++;
										}else{
											break;
										}
									}else{
										break;
									}
								}
								UnmapViewOfFile(lpFileData);
							}else{
								dwRet=GetLastError();
							}
							CloseHandle(hFileMap);
						}else{
							dwRet=GetLastError();
						}
						CloseHandle(hFile);
					}else{
						dwRet=GetLastError();
					}
				}
			}
		}
	}

	if (dwRet==NO_ERROR)
	{
		MessageBox(NULL,TEXT("Done"),TEXT("V Cards extractor"),(MB_OK|MB_ICONINFORMATION));
	}else{
		ReportError(dwRet);
	}

#ifdef _DEBUG
	return(dwRet);
#else
	ExitProcess(dwRet);
#endif //_DEBUG
}


BOOL BrowseForFolder(HWND hwndOwner,LPCTSTR lpcszTitle,LPTSTR lpszPath)
{
	LPCITEMIDLIST pidl;
	BROWSEINFO biBrowseInfo={0};
	
	biBrowseInfo.hwndOwner=hwndOwner;
	biBrowseInfo.lpszTitle=lpcszTitle;
	SHGetSpecialFolderLocation(hwndOwner,CSIDL_DESKTOP,(LPITEMIDLIST*)&biBrowseInfo.pidlRoot);
	biBrowseInfo.ulFlags=BIF_RETURNONLYFSDIRS|BIF_EDITBOX|BIF_NEWDIALOGSTYLE|BIF_NONEWFOLDERBUTTON|BIF_UAHINT;

	pidl=SHBrowseForFolder(&biBrowseInfo);
	if (pidl)
	{
		SHGetPathFromIDList(pidl,lpszPath);
		CoTaskMemFree((LPVOID)pidl);
	}
return(pidl!=0);
}



DWORD QPUTF8_To_QPWin1251(LPBYTE lpBuff,SIZE_T dwBuffSize,LPBYTE lpBuffOut,SIZE_T dwBuffOutSize,SIZE_T *pdwBuffOutSizeRet)
{
	DWORD dwRetErrorCode=NO_ERROR;

	SIZE_T i,tm;
	LPBYTE lpBuffOutCur=lpBuffOut;

	for(i=0;i<dwBuffSize;i++)
	{
		if (lpBuff[i]=='=' && (i-dwBuffSize)>5)
		{
			switch((*((WORD*)(lpBuff+i+1)))){
			case '0D':
				if ((*((WORD*)(lpBuff+(i+4))))==(*((WORD*)"\r\n"))) i+=3;
				(*lpBuffOutCur++)=ByteFromHex((*((WORD*)(lpBuff+(i+4)))))+0x30;
				i+=5;
				break;
			case '1D':
				if ((*((WORD*)(lpBuff+(i+4))))==(*((WORD*)"\r\n"))) i+=3;
				(*lpBuffOutCur++)=ByteFromHex((*((WORD*)(lpBuff+(i+4)))))+0x70;
				i+=5;
				break;
			case '02':
				(*lpBuffOutCur++)=' ';
				i+=2;
				break;
			case 2573: //CRLF
				i+=2;
				break;
			default:
				/*tm=(*((WORD*)(lpBuff+i+1)));
				tm=((*((WORD*)(lpBuff+(i+4)))));
				tm=ByteFromHex((*((WORD*)(lpBuff+(i+4)))));
				tm=ByteFromHex((*((WORD*)(lpBuff+(i+4)))));*/
				i+=2;
				/*(*lpBuffOutCur++)=ByteFromHex((*((WORD*)(lpBuff+(i+4)))));
				i+=5;//*/
				break;
			}
		}else{
			if ((*((WORD*)lpBuff+i))==(*((WORD*)"\r\n")) && (*(lpBuff+i+2))=='=')
			{
				i+=1;
			}else{
				(*lpBuffOutCur++)=(*(lpBuff+i));
			}
		}
	}

	if (pdwBuffOutSizeRet) (*pdwBuffOutSizeRet)=lpBuffOutCur-lpBuffOut;

return(dwRetErrorCode);
}